#!/usr/bin/python3

import getpass
import hashlib
import os

username = getpass.getuser()

print(f'Hi, {username}!\n')
print('This utility will help you to prepare or reset your .cookie_auth file for the IMC\'s Cookie Authorization System.')
print('Please enter new password/passphrase for your account.')
print('Note that SHA512 hash of this password (concatenated with your username) will be stored in ~/.config/imc/.cookie_auth file and may be exposed to the Internet.\n')

while True:
    password = getpass.getpass('Enter a new password: ')
    if getpass.getpass('Repeat that again: ') == password:
        break
    else:
        print('Entered passwords doesn\'t match!')

pwd_hash = hashlib.sha512()
pwd_hash.update(
    (password + username).encode('utf8')
)
pwd_hash = pwd_hash.hexdigest()

folder_path = os.path.expanduser('~/.config/imc')
try:
    os.mkdir(folder_path)
except Exception:
    pass
os.chmod(folder_path, 0o755)

file_path = os.path.expanduser('~/.config/imc/.cookie_auth')
with open(file_path, 'w') as f:
    f.write(pwd_hash)
os.chmod(file_path, 0o744)

print('\nSuccessfully initialized. Thank you!')
print('Please keep 744 permissions on that file and 755 on folder, or else you may encounter errors.')
